/* gameio.c */
/*input output*/

#include<stdio.h>
#include <termios.h>
#include <unistd.h>
#include <sys/signal.h>
#include <stdlib.h>
#include <curses.h>

static WINDOW *win;/*stasic＋関数で値を残せる*/

static void signal_handler(int unused)
{
  printf("handler\n");
  endwin();
  exit(EXIT_SUCCESS);
}

static void set_signalhandlers(void)
{
  signal(SIGHUP, signal_handler);/*signal 関数は, 引数 sig で指定されたシグナル番号に応じて, 引数 func で指定されたシグナルハンドラ (signal handler) を実行します.abort 関数または, raise 関数で呼び出されるシグナルハンドラ内でraise 関数を呼び出してはいけません.*/
  signal(SIGINT/*キーボードからの割り込み*/, signal_handler);
  signal(SIGILL/*不正な命令*/, signal_handler);
  signal(SIGTERM/*終了*/,signal_handler);
  signal(SIGQUIT/*キーボードによる中止*/,signal_handler);
}

void gameioinit(void){
  set_signalhandlers();/*上*/
  win = initscr();
  nodelay(win,TRUE);
  cbreak();
  noecho();
}

int gameioread(){
  int ret = getch();
  if (ret <=0){
    return 0;
  }else{
    return ret;
  }
}

void gameiopost(void){
  nocbreak();
  echo();
  endwin();
}

void gameioclear(){
  clear();
}

void gameiorefresh(void){
  refresh();
}

void gameioput(int x, int y, char ch){
  mvaddch(y,x,ch);/*move'カーソルの移動' + addch'一文字の表示'*/
}

void gameiousleep(int t){
  usleep(t);
}
