/* gamemain2.c */

#include<scenario.h>
#include<screen.h>
#include<gameio.h>
#include<walls.h>
#include<stdio.h>
#include<enemy.h>
#include<movingobjectmanager.h>
#ifdef DEBUG
#include<log.h>
#include<event.h>
#endif

#define OBJNUM 7
#define MOBJNUM 12
#define EVNUM 20

object* objp[OBJNUM];
movingobject* mobjp[MOBJNUM];
event* ev[EVNUM];
vector2 mypos;
vector2 itempos;
int isfire;
int score;
int speedlevel;
int choice;
int itemer;
int count;

void onestepb(movingobject* mobj){
  vec2add(&(mobj->pos), &(mobj->vel));
}

void dispb(movingobject* mobj){
  putobject(*(mobj->obj), mobj->id, mobj->pos.x, mobj->pos.y);
}

void dispm(movingobject* mobj){
  putobject(*(mobj->obj), 0, mobj->pos.x, mobj->pos.y);
}

void dispitem(movingobject* mobj){
  putobject(*(mobj->obj), 0, mobj->pos.x, mobj->pos.y);
}

int bomba(movingobject* mobj){
  score+=50;
  return 1;
}

int bombm(movingobject* mobj){
  return 1;
}

int bombitem(movingobject* mobj){
  score+=150;
  return 1;
}

void initobjects(void){
  objp[0] = newobject(1,1,"*");
  objp[1] = newobject(3,2," ^ +*+ ");
  objp[2] = newobject(2,1,"$$");
}

void initmovingobjects(void){
  mobjp[0] = newenemy();/*縦*/
  mobjp[1] = newmovingobject(&objp[0], onestepb, dispb, bomba, "bullet");
  mobjp[2] = newmovingobject(&objp[1], NULL, dispm, bombm, "me");
  mobjp[3] = sideenemy();
  mobjp[4] = sideenemy2();
  mobjp[5] = newmovingobject(&objp[2], onestepb, dispitem, bombitem,"item");
  mobjp[6] = bulletenemy();/*弾*/
  mobjp[7] = newenemy_chitose1();
  mobjp[8] = newenemy_chitose2();
  mobjp[9] = maynewenemy();
  mobjp[10] = maynewenemy2();
}

void setevents(void){
  int i;
  ev[0] = newevent(3, makevector2(20,15),makevector2(0,0.4), mobjp[4],"w0");
  ev[1] = newevent(5, makevector2(15,1),makevector2(0.5,0.7), mobjp[3],"b0");
  ev[2] = newevent(10, makevector2(10,10),makevector2(0,0.2), mobjp[0],"h0");
  ev[3] = newevent(15, makevector2(25,5),makevector2(0,0.4), mobjp[0],"w0");
  ev[4] = newevent(15, makevector2(25,8),makevector2(0,1), mobjp[6],"b1");
  ev[5] = newevent(25, makevector2(10,15),makevector2(0.2,0.2), mobjp[4],"w1");
  ev[6] = newevent(30, makevector2(15,3),makevector2(0.5,0.3), mobjp[3],"h1");
  ev[7] = newevent(30, makevector2(25,3),makevector2(0.4,0.6), mobjp[4],"w2");
  ev[8] = newevent(35, makevector2(15,3),makevector2(0.1,0.3), mobjp[9],"h3");
  ev[9] = newevent(40, makevector2(20,3),makevector2(0,0.2), mobjp[8],"b2");
  ev[10] = newevent(40, makevector2(20,7),makevector2(0,1), mobjp[6],"b3");
  ev[11] = newevent(45, makevector2(25,9),makevector2(0.2,0.5), mobjp[10],"h3");
  ev[12] = newevent(50, makevector2(20,3),makevector2(0.2,0.3), mobjp[4],"h2");
  ev[13] = newevent(50, makevector2(30,1),makevector2(0,1), mobjp[3],"b4");
  ev[14] = newevent(55, makevector2(25,4),makevector2(0.1,0.5), mobjp[7],"h3");
  ev[15] = newevent(60, makevector2(20,2),makevector2(0.2,0.6), mobjp[8],"h3");
  ev[16] = newevent(65, makevector2(30,9),makevector2(0.2,0.3), mobjp[8],"h3");
  ev[17] = newevent(70, makevector2(25,8),makevector2(0.1,0.7), mobjp[7],"h3");
  ev[18] = newevent(1000000, 
                   makevector2(30,1),makevector2(0,1), mobjp[0],"dummy");

  for(i=0;i<EVNUM;i++){
    addevent(ev[i]);
  }
  resetmark();
}


void init(void){
  initscreen();
  initwalls();
  initmom();
  initobjects();
  initmovingobjects();
  initscenario();
  setevents();
}


void getstate(vector2* ret, int* isfire){
  static vector2 pos = {SCREENWIDTH/2-1, SCREENHEIGHT-3}; 
  *isfire = 0;
  int in = gameioread();
  switch(in){
  case '2':
    pos.x++;
    break;
  case '1':
    pos.x--;
    break;
  case 'i':
    pos.y--;
    break;
  case 'k':
    pos.y++;
    break;
  case ' ':
    *isfire = 1;
  } 
  *ret = pos;
}

void getstateitem(vector2* ret){
  static vector2 pos = {SCREENWIDTH/2-1, 3}; 
  int in = gameioread();
  *ret = pos;
}

void show(void){
  int x,y;
  for(y=0;y<SCREENHEIGHT;y++){
    for(x=0;x<SCREENWIDTH;x++){
      gameioput(x,y,dispbuffer[SCREENWIDTH*y+x]);
    }
  }
  gameiorefresh();
}

void gameloop(void){ 
  int time=0;
  vector2 itempv;
  vector2 tmpv;
  event* e = getnextevent();
  while(1){
    gameiousleep(30000);
    if(time%speedlevel == 0){
      scrollwall();
      while(e!= NULL && e->time*speedlevel < time){
        addmo(e->mobj, e->pos, e->vel);
        e = getnextevent();
      }
      if(choice==1){
        score++;
      }
      if(choice==2){
	score+=2;
      }
      if(choice==3){
	score+=3;
      }
      if(choice==4){
	score+=4;
      }
      if(time%100==0 && speedlevel>2)
	speedlevel=speedlevel-2;
    }
    getstate(&mypos, &isfire);
    getstateitem(&itempos);
    gameioput(SCREENWIDTH+3,1,'p');
    gameioput(SCREENWIDTH+4,1,'o');
    gameioput(SCREENWIDTH+5,1,'s');
    gameioput(SCREENWIDTH+6,1,'i');
    gameioput(SCREENWIDTH+7,1,'t');
    gameioput(SCREENWIDTH+8,1,'i');
    gameioput(SCREENWIDTH+9,1,'o');
    gameioput(SCREENWIDTH+10,1,'n');
    gameioput(SCREENWIDTH+12,1,'0'+(int)mypos.x/10);
    gameioput(SCREENWIDTH+13,1,'0'+(int)mypos.x%10);
    gameioput(SCREENWIDTH+15,1,'0'+(int)mypos.y/10);
    gameioput(SCREENWIDTH+16,1,'0'+(int)mypos.y%10);
    gameioput(SCREENWIDTH+3,2,'s');
    gameioput(SCREENWIDTH+4,2,'c');
    gameioput(SCREENWIDTH+5,2,'o');
    gameioput(SCREENWIDTH+6,2,'r');
    gameioput(SCREENWIDTH+7,2,'e');
    gameioput(SCREENWIDTH+9,2,'0'+(int)score/100);
    gameioput(SCREENWIDTH+10,2,'0'+(int)(score%100)/10);
    gameioput(SCREENWIDTH+11,2,'0'+(int)score%10);
    gameioput(SCREENWIDTH+3,3,'l');
    gameioput(SCREENWIDTH+4,3,'i');
    gameioput(SCREENWIDTH+5,3,'f');
    gameioput(SCREENWIDTH+6,3,'e');
    gameioput(SCREENWIDTH+8,3,'3'-(int)count%10);
    putwalls(SCREENHEIGHT);
    putmo();
    onestepmo();
    if(checkcollision(mypos, objp[1])!=NONOBJ){
      count++;
    }
    if(count>3){
      break;
    }
    if(score>999){
      break;
    }
    if(isfire){
      tmpv = mypos;
      tmpv.x +=1;
      tmpv.y -=2;
      addmo(mobjp[1], tmpv, makevector2(0,-1));
    }
    if(time%300==0 && time !=0){
      itempv = itempos;
      itempv.x +=1;
      itempv.y -=2;
      addmo(mobjp[5],itempv,makevector2(0,1));
    }
    mobjp[2]->pos = mypos;
    dispm(mobjp[2]);
    mobjp[5]->pos = itempos;
    dispb(mobjp[5]);
    show();
    time++;
  }
}

void explanation(void){
  int start;
  printf("上移動はi、下移動はk、左移動は1、右移動は2を押してください\nスペースキーを押すと弾が発射されます\n");
  printf("レベルを選んでください\nEASY->1 NORMAL->2 HARD->3 EXPERT->4\n");
  scanf("%d",&choice);
  if(choice == 1){
    speedlevel=30;
    printf("あなたはEASYを選択しました\n");
  }
  if(choice == 2){
    speedlevel=20;
    printf("あなたはNORMALを選択しました\n");
  }
  if(choice == 3){
    speedlevel=10;
    printf("あなたはHARDを選択しました\n");
  }
  if(choice ==4){
    speedlevel=5;
    printf("あなたはEXPERTを選択しました\n");
  }
  printf("Are you ready??? (1を入力すると始まります)\n");
  scanf("%d",&start);
  if(start==1){
    printf("Let's start!!\n");
  }
}

int main(void){
  explanation();
  gameioinit();
  gameioclear();
  init();
  count=0;
  score=0;
  gameloop();

  gameiopost();
  printf("score %d\n",score);
  return 0;
}
